;**** Directives created by AutoIt3Wrapper_GUI ****
; ------------------------------------------------------------------------------
;
;					winPenPack Mozilla builder
;
; ------------------------------------------------------------------------------
;
; AutoIt Version:			3.3.16.1
; Platform:					Windows
; Script Name:				winPenPack Mozilla builder
; Script Function:			Installazione applicazioni mozilla
; Script Version:			1.3.0.0
; Author:					Gabriele Tittonel <tittoproject@gmail.com>
; Modified:					Energy (multilingua, licenza, gestione errori, tray), ZioZione (multilingua,download automatico), Michele Pezza (edit to manage new path in mozilla Site, update for 3.3.16.1, downloadprogress bar)
; Home Page:				http://www.winpenpack.com
; License:					GNU General Public License
; Contributors:				winPenPack Team
;
; ------------------------------------------------------------------------------

#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=graphics/x-icon.ico
#AutoIt3Wrapper_Outfile=build_mozilla.exe
#AutoIt3Wrapper_UseUpx=y
#AutoIt3Wrapper_Res_Comment=Mozilla Builder
#AutoIt3Wrapper_Res_Description=Mozilla Builder
#AutoIt3Wrapper_Res_Fileversion=1.3.0.0
#AutoIt3Wrapper_Res_LegalCopyright=GNU General Public License
#AutoIt3Wrapper_Res_Language=1040
#AutoIt3Wrapper_Res_requestedExecutionLevel=None
#AutoIt3Wrapper_Res_Field=ProductName|Mozilla Builder
#AutoIt3Wrapper_Res_Field=ProductVersion|1.1
#AutoIt3Wrapper_Res_Field=OriginalFilename|build_mozilla.exe
#AutoIt3Wrapper_Res_Field=InternalName|build_mozilla
#AutoIt3Wrapper_Res_Field=CompanyName|www.winpenpack.com
#AutoIt3Wrapper_Res_Field=eMail|winpenpack@gmail.com
#AutoIt3Wrapper_Res_Field=Author|winPenPack Team
#AutoIt3Wrapper_Res_Field=LegalTrademarks|winPenPack
#AutoIt3Wrapper_Res_Field=AutoIt Version|%AutoItVer%
#AutoIt3Wrapper_Run_Debug_Mode=N			;(Y/N)Run Script with console debugging. Default=N
#EndRegion

#include <String.au3>
#include <INet.au3>

;---------------------- VARIABLES ----------------------------------------------
; Tray icon exit
Opt("MustDeclareVars", 1)
Opt("TrayAutoPause", 0)
Opt("TrayOnEventMode",1)
Opt("TrayMenuMode",1)
TrayCreateItem("Exit")
TrayItemSetOnEvent(-1,"_Exit_Script")
TraySetState()

; Script Info
Global $ScriptName = 'winPenPack Mozilla builder'
TraySetToolTip($ScriptName)

;Ini info
Global $LauncherIni = StringLeft(@ScriptFullPath, StringLen(@ScriptFullPath)-4) & '.ini'

; Global Dirs
Global $BuilderRoot = @ScriptDir
Global $Root = _FullPath('..\..\..', @ScriptDir)
Global $Bin = _FullPath('.\Bin')
Global $Lib = _FullPath('.\Lib')

; Path
Local $path = IniRead($LauncherIni,'Environment','PATH','')
If $path <> '' Then
	Opt('ExpandVarStrings',1)
	_SetPath($path)
	Opt('ExpandVarStrings',0)
EndIf

; App Info
Global $AppName = IniRead($LauncherIni,'Setup','AppName','')
Global $AppFile = StringLower($AppName) & '.exe'
Global $AppNameFull = 'X-' & $AppName
Global $LicensePath = _FullPath('.\LICENSE', $BuilderRoot)

; Directories
Global $OutDir = $Bin & '\' & $AppName
Global $SetupDir = _FullPath('.\setup', $BuilderRoot)
Global $LangDir = $Lib & '\Mozilla'

; Remote links
Global $sSetupURL = IniRead($LauncherIni,'Environment','X_SETUP_REMOTE_LINK','')
Global $Version = IniRead($LauncherIni,'Environment','VERSION','')
Global $OS = IniRead($LauncherIni,'Environment','OS','')
Global $Prefix = IniRead($LauncherIni,'Environment','X_SETUP_REMOTE_FILE','')
Global $Prefile = IniRead($LauncherIni,'Environment','X_SETUP_FILE','')

Global $baseFile = $Prefile&' '&$Version&'.exe'
Global $baseSetupURL = $sSetupURL&'/'&$Version&'/'&$OS
Global $baseSetupFile = $Prefix&$Version&'.exe'
Global $sDownloaderTitle = IniRead($LauncherIni,'Environment','X_DOWNLOADER_NAME','')

; Localizations
Global $LangList = ''
Global $LangOther = ''
Global $MsgInfoText, $MsgInfoTitle, $MsgInfoAccept, $MsgInfoLang, $MsgInfoLicense, $MsgInfoCancel, $MsgInfoRun, $MsgInfoDownload, $MsgDownloadTooltip
Global $aLangList = IniReadSection($LauncherIni,"Languages")
Global $LangIni = $LangDir & '\lang.ini'
Global $instLanguage = ''


#EndRegion Variables


; ------------------------------------------------------------------------------
; Log
; ------------------------------------------------------------------------------
Global $WriteLog = IniRead($LauncherIni,'Options','WriteLog','false')
Global $Log = @ScriptDir & '\' & $AppName & '.log'

If $WriteLog = 'true' Then
	IniWrite($Log, 'Environment', 'AppName', $AppName)
	IniWrite($Log, 'Environment', 'AppFile', $AppFile)
	IniWrite($Log, 'Environment', 'AppNameFull', $AppNameFull)
	IniWrite($Log, 'Environment', 'LicensePath', $LicensePath)
	IniWrite($Log, 'Environment', 'LauncherIni', $LauncherIni)
	IniWrite($Log, 'FileSystem', 'OutDir', $OutDir)
	IniWrite($Log, 'FileSystem', 'LangDir', $LangDir)
	IniWrite($Log, 'FileSystem', 'SetupDir', $SetupDir)
	IniWrite($Log, 'FileSystem', 'sSetupURL', $sSetupURL)
 	IniWrite($Log, 'FileSystem', 'BuilderRoot', $BuilderRoot)
	IniWrite($Log, 'FileSystem', 'Root', $Root)
 	IniWrite($Log, 'FileSystem', 'Bin', $Bin)
 	IniWrite($Log, 'FileSystem', 'Lib', $Lib)
	IniWrite($Log, 'FileSystem', 'PATH', EnvGet('PATH'))
    IniWrite($Log, 'FileSystem', 'baseSetupURL', $baseSetupURL)
	IniWrite($Log, 'FileSystem', 'baseSetupFile', $baseSetupFile)
EndIf

#Region Main Procedure
;---------------------- MAIN PROCEDURE -----------------------------------------
; Set OS language
Global $Lang = _Language()

; Check if process is already running
If ProcessExists($AppFile) Then
   _Error_Msg("AppAlreadyRunning")
	Exit 2
EndIf

; Set localized descriptions for user interface
_MsgInfo(_LangDescFromCode($Lang))

; Check if lang.ini file exists
If FileExists($LangIni) Then
   $instLanguage = IniRead($LangIni,$AppName,"lang",'')
   If Not $instLanguage = '' Then
       _MsgInfo(_LangDescFromCode($instLanguage))
   EndIf
EndIf
If $instLanguage = '' Then
   ; User choose language from combo
   Local $selLanguage = _SelectLang(True)
   ; Set remote dir language
   Global $instLanguage = _LangCodeFromDesc($selLanguage)
   ; Create "lang.ini" file for next installations/upgrades
   IniWrite($LangIni,$AppName,"lang",$instLanguage)
EndIf

; Search setup file
Global $SetupName = _FindSetup($SetupDir)

; Setup not found (First run default condition)
If @error Then

	; Build remote file name
	Global $sRemoteFileName = _BuildRemoteFileName($instLanguage)
	If @error Then
		  Switch @error
			 Case 2
				_Error_Msg("RemoteSetupNotFound")
			 Case 3
				_Error_Msg("RemoteSetupNotFound")
			 Case Else
				_Error_Msg("SetupFileNotDownloaded")
		  EndSwitch

		  Exit 4
	  EndIf

	; Setup file
	;Global $sSetupDown = $SetupDir & "\" & $sRemoteFileName
    Global $sSetupDown = $SetupDir & "\" & $baseFile

    	If $WriteLog = 'true' Then
	IniWrite($Log, 'FileSystem', 'SetupDown',$sSetupDown)
	EndIf

   ; Ask user if download choosed setup file
   Local $iMsgBoxAnswer = MsgBox(1 + 32 + 262144, $ScriptName, $MsgInfoDownload)
   ;If user answer is NO the exit procedure...
   If $iMsgBoxAnswer = 2 Then Exit 1
   ;...else continue: build remote URL of setup to download
   ;Local $sRemoteURL = $sSetupURL & "/" & $instLanguage & "/" & $sRemoteFileName
   Local $sRemoteURL = $baseSetupURL & "/" & $instLanguage & "/" & $baseSetupFile
   If $WriteLog = 'true' Then
	IniWrite($Log, 'FileSystem', 'RemoteURL',$sRemoteURL)
	EndIf
   ;download setup file
   _Download($sRemoteURL, $sSetupDown)
   ;If download error, then exit
   If @error Or Not FileExists($sSetupDown) Then
	  Switch @error
		 Case 1
			_Error_Msg("SetupDestDirNotFound")
		 Case 2
			_Error_Msg("SetupDestDirPathBadFormed")
		 Case 3
			_Error_Msg("RemoteSetupNotFound")
		 Case 4
			_Error_Msg("RemoteSetupIncorrectSize")
		 Case 5
			_Error_Msg("RemoteSetupNotRead")
		 Case 6
			_Error_Msg("RemoteSetupPartiallyRead")
		 Case Else
			_Error_Msg("SetupFileNotDownloaded")
	  EndSwitch

	  Exit 4
   EndIf
   ;performs another search for setup file (now it should be correctly found and its name is assigned to the variable)
   $SetupName = _FindSetup($SetupDir)
EndIf
; Builds absolute path of setup file
Global $SetupFile = $SetupDir & '\' & $SetupName
If Not FileExists($SetupFile) Or StringInStr(FileGetAttrib($SetupFile), 'D') Then _Error_Msg("SetupFileNotFound", $SetupFile)

; Extract setup
If $OutDir = "" Then _Error_Msg("InstallDirNotFound")
; Remove then recreate $Bin$\$AppName$ folder
DirRemove($OutDir, 1)
DirCreate($OutDir)
; Uncompress setup file
Local $iError = RunWait('7za x "' & $SetupFile & '" -o"' & $OutDir & '"', $SetupDir, @SW_HIDE)
If @error Then _Error_Msg("7zaNotFound")
If $iError > 0 Then _Error_Msg("InstallationFailed!")
; Change current working directory to the $Bin$\$AppName$ folder
If FileChangeDir($OutDir) = 0 Then _Error_Msg("WorkingDirNotFound")
; Delete all files found
FileDelete('*')
; Moves all extracted folders contents into $Bin$\$AppName$ folder
_InstallExtractedFolders()
;_DirMove('core', '.', 1)

;Remove self folder
;_DeleteMe()

GUIDelete()
GUIDelete()

#EndRegion Main Procedure

#Region Funzioni
;---------------------- FUNCTIONS ----------------------------------------------

; Clean GUI and exit script
Func _Exit_Script()
   GUIDelete()
   GUIDelete()
   _Error_Msg("InterruptedByUser")
   Exit 1
EndFunc   ;==>_Exit_Script

; Collects commandline parameters
;~ Func _CmdLineParam($aParam = $CmdLine)
;~    Local $sParam = ''
;~    If $aParam[0] >= 1 Then
;~ 	  For $i = 1 To $aParam[0]
;~ 		 Local $sTags = StringLeft($aParam[$i], 1)
;~ 		 Local $sQuote = '"'
;~ 		 If $sTags = '-' Or $sTags = '/' Then $sQuote = ''
;~ 		 $sParam &= ' ' & $sQuote & $aParam[$i] & $sQuote
;~ 	  Next
;~    EndIf
;~    Return $sParam
;~ EndFunc   ;==>_CmdLineParam

; Searches an executable in $path folder
Func _FindSetup($path)
   Local $search = FileFindFirstFile($path & '\*.exe')
   If $search = -1 Then Return SetError(1,0,1)
   Local $find = FileFindNextFile($search)
   If @error Then Return SetError(1,0,0)
   FileClose($search)
   Return $find
EndFunc   ;==>_FindSetup

; Moves a folder from $source to $dest with all its contents. $flag=1 overwrites existing files/folders
Func _DirMove($source, $dest, $flag = 0)
   If StringInStr('/\', StringRight($dest, 1)) Then
	  If FileExists($dest) Then
		 Return DirMove($source, $dest, $flag)
		 Else
			$dest &= _DirName($source)
	  EndIf
   EndIf

   Local $destCreate = DirCreate($dest)
   If Not $destCreate Then Return
   FileMove($source & '\*', $dest, $flag)

   Local $dirList = _FileList($source, '*', 2)
   If Not @error Then
	  For $i = 1 To $dirList[0]
		 If FileExists($dest & '\' & $dirList[$i]) Then
			_DirMove($source & '\' & $dirList[$i], $dest & '\' & $dirList[$i], $flag)
		 Else
			DirMove($source & '\' & $dirList[$i], $dest & '\' & $dirList[$i], $flag)
		 EndIf
		 DirRemove($source & '\' & $dirList[$i])
	  Next
   EndIf
   DirRemove($source)
EndFunc   ;==>_DirMove

; Returns the folder name given the full path
Func _DirName($path)
   $path = _StringStripTrailingSlash($path)
   Return StringTrimLeft($path, StringInStr($path, '\', 2, -1))
EndFunc   ;==>_DirName

; Strips eventual trailing slash from a string
Func _StringStripTrailingSlash($string)
   If StringRight(StringReplace($string, '/', '\'), 1) = '\' Then
	  Return _StringStripTrailingSlash(StringTrimRight($string, 1))
   EndIf
   Return $string
EndFunc   ;==>_StringStripTrailingSlash

; Returns the list of all files contained in $path folder
Func _FileList($path, $filter = '*', $flag = 0)
   If Not FileExists($path) Then Return SetError(1, 0, 0)
   If Not StringInStr(FileGetAttrib($path), 'D') Then Return SetError(2, 0, 0)
   Local $splitFilter = StringSplit($filter, ' '), $list[1]
   For $i = 1 To $splitFilter[0]
	  Local $handle = FileFindFirstFile($path & '\' & $splitFilter[$i])
	  While 1
		 Local $file = FileFindNextFile($handle)
		 If @error Then ExitLoop
		 Local $isDir = _FileIsDir($path & '\' & $file)
		 If $flag = 1 And $isDir = True Then ContinueLoop
		 If $flag = 2 And $isDir = False Then ContinueLoop
		 ReDim $list[UBound($list) + 1]
		 $list[0] += 1
		 $list[$list[0]] = $file
	  WEnd
	  FileClose($handle)
   Next
   If UBound($list) = 1 Then Return SetError(3, 0, 0)
   Return $list
EndFunc   ;==>_FileList

; Returns TRUE if $path is a folder, else returns FALSE
Func _FileIsDir($path)
   If StringInStr(FileGetAttrib($path), 'D', 2) Then Return True
   Return False
EndFunc   ;==>_FileIsDir

; Populate global string with localized info to be shown to the user
Func _MsgInfo($lang)
   Opt("ExpandVarStrings", 1)
   ; Read language code
   Local $langCode = _LangCodeFromDesc($lang)
   ; If language code is not explicitly defined, use "else" language (en-US)
   $langCode = _FindLocalization($langCode)
   ; Assign strings to GUI variables
   $MsgInfoTitle = _ReadIniStrings('MsgInfoTitle',$langCode)
   $MsgInfoText = _ReadIniMessages($langCode)
   $MsgInfoAccept = _ReadIniStrings('MsgInfoAccept',$langCode)
   $MsgInfoCancel = _ReadIniStrings('MsgInfoCancel',$langCode)
   $MsgInfoLang = _ReadIniStrings('MsgInfoLang',$langCode)
   $MsgInfoLicense = _ReadIniStrings('MsgInfoLicense',$langCode)
   $MsgInfoDownload = _ReadIniStrings('MsgInfoDownload',$langCode)
   $MsgDownloadTooltip = _ReadIniStrings('MsgDownloadTooltip',$langCode)
   $MsgInfoRun = _ReadIniStrings('MsgInfoRun',$langCode)

   Opt("ExpandVarStrings", 0)
EndFunc

; GUI for show info to the user and accept language choice input
Func _SelectLang($LangSel)
   Local $msg,$sCurrCombo,$sText
   Local $oShell = ObjCreate("Shell.Explorer")
   Local $gui = GUICreate($MsgInfoTitle, 550, 280)
   GUISetFont (10)

   Local $MsgInfo = GUICtrlCreateObj($oShell, 0, 0, 549, 230)
   Local $select = GUICtrlCreateLabel($MsgInfoLang, 20, 242, 200, 25)
   If Not $LangSel Then GUICtrlSetState(-1, 32)
   Local $combo = GUICtrlCreateCombo('', 200, 238)
   If Not $LangSel Then GUICtrlSetState(-1, 32)
   ; Read all languages and populate the combo
   _ReadLanguage()
   GUICtrlSetData($combo, $LangList, _LangDescFromCode($Lang))

   Local $button = GUICtrlCreateButton("OK", 400, 238, 90, 25)
   GUISetState(@SW_SHOW)
   With $oShell; Object tag pool
	  .navigate("about:blank")
	  While .busy
		 Sleep(100)
	  WEnd
	  .document.writeln('<BODY onselectstart = "return false" oncontextmenu="return false" ondragover="return false" style="font-family: Arial, Helvetica, sans-serif ;font-size: 9px;">')
	  .document.body.topmargin=5
	  .document.body.leftmargin=5
	  .document.body.scroll="auto"
	  .document.body.style.fontSize = "15px"
	  .document.body.innerHTML = $MsgInfoText
   EndWith
   ; Main loop
   While 1
	  Switch GUIGetMsg()
		 Case -3
			_Exit_Script()
		 Case $button
			$Lang = GUICtrlRead($combo)
			ExitLoop
		 Case $combo
			_MsgInfo(GUICtrlRead($combo))
			$oShell.document.body.innerHTML = $MsgInfoText
			GUICtrlSetData($select, $MsgInfoLang)
			WinSetTitle($gui, '',$MsgInfoTitle)
	  EndSwitch
	  ; Gets the selected language from combo
	  If GUICtrlRead($combo) <> $sCurrCombo Then
		 $sText = GUICtrlRead($combo)
		 $sCurrCombo = $sText
	  EndIf
   WEnd

   ; Show license, if exists
   GUICtrlDelete ($combo)
   GUICtrlDelete ($select)
   If FileExists($LicensePath) Then
	  Local $sLicense = FileRead($LicensePath)
	  $sLicense = StringRegExpReplace ($sLicense, '(?Ui)(http://)?(www.+)([\.,]?\s)', '<a href="http://\2" target="_blank">\2</a>\3')
	  $sLicense = StringRegExpReplace ($sLicense, '\n', '<br>')
	  $oShell.document.body.scroll="yes"
	  $oShell.document.body.innerHTML = $sLicense
	  WinSetTitle ($gui, '',$MsgInfoLicense)
	  GUICtrlSetData($button, $MsgInfoAccept)
	  Local $button2 = GUICtrlCreateButton($MsgInfoCancel, 250, 238, 90, 25)

	  While 1
		 Switch GUIGetMsg()
			Case -3
			   _Exit_Script()
			Case $button2
			   _Exit_Script()
			Case $button
			   ExitLoop
		 EndSwitch
	  WEnd

   EndIf
   GUICtrlDelete ($button)
   If FileExists($LicensePath) Then GUICtrlDelete ($button2)
   GUICtrlDelete ($MsgInfo)
   GUIDelete($gui)

   ; Show "Please wait" window until setup is finished, then destroy
   Local $gui = GUICreate($MsgInfoTitle, 420, 150, -1, -1, BitOR(0x00800000, 0x80000000, 0x04000000), BitOR(0x00000008, 0x00000080))
   GUISetBkColor(0xFFFFFF)
   GUICtrlCreateLabel("", 0, 0, 420, 150, -1, 0x00100000)
   GUICtrlSetBkColor(-1, -2)
   GUISetState(@SW_SHOW)
   WinSetTrans($gui,"",150)
   Local $gui2 = GUICreate("IE", 420, 150, -3, -25, 0x80000000, BitOR(0x00080000, 0x00000080, 0x00000040),$gui)
   GUISetBkColor(0xFFFFFF)
   GUICtrlCreatePic(@ScriptDir & "\load.gif", 210, 18, 1, 1)
   Local $MsgInfo = GUICtrlCreateObj($oShell, 0, 0, 420, 150)
   With $oShell
	  .navigate("about:blank")
	  While .busy
		 Sleep(100)
	  WEnd

	  .document.writeln('<BODY onselectstart = "return false" oncontextmenu="return false" ondragover="return false">')
	  .document.body.style.border="0px"
	  .document.body.topmargin=18
	  .document.body.leftmargin=0
	  .document.body.scroll="no"
	  .document.body.style.fontSize = "16px"
	  .document.body.innerHTML = $MsgInfoRun
   EndWith
   GUISetState(@SW_SHOW)
   GUISetState(@SW_DISABLE)
   $oShell = 0

   Return $sText
EndFunc

; Downloads a file from $Url into $Dest folder
Func _Download($sURL, $sDest, $iMinByte = 1)
   If StringInStr(FileGetAttrib($sDest), 'D', 2) <> 0 Then Return SetError(1, 0, 0)

   Local $aPath = StringRegExp($sDest, "^(.*?)[\\/]?([^\\/]+)$", 1)
   If @error Then Return SetError(2, 0, 0)

   If Not FileExists($aPath[0]) Then DirCreate($aPath[0])
   Local $iFileSize = InetGetSize($sURL)
   If @error Then Return SetError(3, 0, 0)

   If $iFileSize < $iMinByte Then Return SetError(4, 0, 0)

   Local $hFileDownload  = InetGet($sURL, $sDest & '.part', $INET_LOCALCACHE, $INET_DOWNLOADBACKGROUND)
   Local $iCount = 0

   ;AutoIt 3.2.12.1 - start
   ; While @InetGetActive
	  ; $iCount = Round(@InetGetBytesRead / $iSize * 100, 0)
	  ; TrayTip($MsgDownloadTooltip, $iCount & "%", 10, 16)
	  ; Sleep(1000)
   ; WEnd
   ; If @InetGetBytesRead = -1 Then Return SetError(5, 0, 0)
   ; If @InetGetBytesRead <> $iSize Then Return SetError(6, 0, 0)
   ;AutoIt 3.2.12.1 - end

   ;AutoIt 3.3.6.1 - start
  ;While InetGetInfo()
  ; While InetGetInfo($hDownload, 0) < $iSize
  	; $iCount = Round(InetGetInfo($hDownload,0) / $iSize * 100, 0)
  	; TrayTip("Download in corso...", $iCount & "%", 10, 16)
  	; Sleep(250)
  ; WEnd
  ; If InetGetInfo($hDownload,1) = -1 Then Return SetError(5, 0, 0)
  ; If InetGetInfo($hDownload,1) <> $iSize Then Return SetError(6, 0, 0)
   ;AutoIt 3.3.6.1 - start
;------------------------------
    ; Declare some general vars
    Local $iMBbytes = 1048576
    Local $bProgressOff = True
	Local $iEndMsgTime = 2000

    ; Show progress UI
    ProgressOn($sDownloaderTitle, "Downloading " & $baseFile)

    ; Keep checking until download completed
    Do
        Sleep(250)

        ; Set vars
        Local $iDLPercentage = Round(InetGetInfo($hFileDownload, $INET_DOWNLOADREAD) * 100 / $iFileSize, 0)
        Local $iDLBytes = Round(InetGetInfo($hFileDownload, $INET_DOWNLOADREAD) / $iMBbytes, 2)
        Local $iDLTotalBytes = Round($iFileSize / $iMBbytes, 2)

        ; Update progress UI
        If IsNumber($iDLBytes) And $iDLBytes >= 0 Then
            ProgressSet($iDLPercentage, $iDLPercentage & "% - Downloaded " & $iDLBytes & " MB of " & $iDLTotalBytes & " MB")
        Else
            ProgressSet(0, "Downloading '" & $baseFile & "'")
        EndIf
    Until InetGetInfo($hFileDownload, $INET_DOWNLOADCOMPLETE)

    ; If the download was successfull, return the target location
    If InetGetInfo($hFileDownload, $INET_DOWNLOADSUCCESS) Then
        ProgressSet(100, "Downloading '" & $baseFile & "' completed")
        If $bProgressOff Then
            Sleep($iEndMsgTime)
            ProgressOff()
        EndIf
		FileMove($sDest & '.part', $sDest, 1)
		Return 0
    ; If the download failed, set @error and return False
    Else
        Local $errorCode = InetGetInfo($hFileDownload, $INET_DOWNLOADERROR)
        ProgressSet(0, "Downloading '" & $baseFile & "' failed." & @CRLF & "Error code: " & $errorCode)
        If $bProgressOff Then
            Sleep($iEndMsgTime)
            ProgressOff()
        EndIf
        SetError(1, $errorCode, False)
    EndIf

;------------------------------

EndFunc   ;==>_Download

; Recognizes OS language
Func _Language()
Select
   Case StringInStr("0410 0810", @OSLang)
	  Return "it"
   Case StringInStr("0413 0813", @OSLang)
	  Return "nl"
   Case StringInStr("040c 080c 0c0c 100c 140c 180c", @OSLang)
	  Return "fr"
   Case StringInStr("0407 0807 0c07 1007 1407", @OSLang)
	  Return "de"
   Case StringInStr("0415", @OSLang)
	  Return "pl"
   Case StringInStr("0416 0816", @OSLang)
	  Return "pt"
   Case StringInStr("040a 080a 0c0a 100a 140a 180a 1c0a 200a 240a 280a 2c0a 300a 340a 380a 3c0a 400a 440a 480a 4c0a 500a", @OSLang)
	  Return "es"
   Case StringInStr("041d 081d", @OSLang)
	  Return "sw"
   Case Else
	  Return "en-US"
   EndSelect
EndFunc

; Transform languages array into "pipe-delimited" string (for combo)
Func _ReadLanguage()
   For $i=0 To $aLangList[0][0]
	  _SetLangPattern($aLangList[$i][1])
   Next
EndFunc

; Concatenate a global string with pipe and input string
Func _SetLangPattern($fLang)
   If $LangList <> '' Then
	  $LangList &= '|' & $fLang
   Else
	  $LangList &= $fLang
   EndIf
EndFunc

; Returns language code from given language description
Func _LangCodeFromDesc($desc)
   Local $code
   For $i=1 To $aLangList[0][0]
	  If $aLangList[$i][1] = $desc Then $code = $aLangList[$i][0]
   Next
   Return $code
EndFunc

; Returns language description given language code
Func _LangDescFromCode($code)
   Local $desc
   For $i=1 To $aLangList[0][0]
	  If $code = $aLangList[$i][0] Then $desc = $aLangList[$i][1]
   Next
   Return $desc
EndFunc

; Reads localized messages from .ini file
Func _ReadIniMessages($lang)
   Local $Message = ''
   Local $aMessages = IniReadSection($LauncherIni,"Messages_"& $lang)
   For $i=1 To $aMessages[0][0]
	  $Message &= $aMessages[$i][1]
   Next
   Return $Message
EndFunc

; Reads localized strings from .ini file
Func _ReadIniStrings($string,$lang)
   Local $str = IniRead($LauncherIni,"Strings_"& $lang,$string,'')
   Return $str
EndFunc


; Reads localized error messages from .ini file
; and shows error message to the user
Func _Error_Msg($sError, $sAddText='', $fContinue=False)
   Opt("ExpandVarStrings", 1)
   Local $str = IniRead($LauncherIni,"Errors_"& _FindLocalization($instLanguage), "ErrMsg" & $sError, '')

   If $sAddText <> '' Then $str &= ": " & $sAddText
   $str = StringReplace($str,"\n",@LF)

   GUIDelete()
   GUIDelete()
   If Not $fContinue Then
	  MsgBox(262160,$AppNameFull & ": ", $str)
	  Exit 3
   EndIf
   MsgBox(262192,$AppNameFull & ": ", $str, 4)
   Opt("ExpandVarStrings", 0)
   Return False
EndFunc   ;==>_Error_Msg


; Search into .ini file for explicit localization
;(means BOTH Messages_$lang AND Strings_$lang).
;If one or both is not found, returns "else"
Func _FindLocalization($lang)
   Local $secMsg = IniReadSection($LauncherIni,"Messages_" & $lang)
   If @error Then
	  Return 'else'
   EndIf

   Local $secStr = IniReadSection($LauncherIni,"Strings_" & $lang)
   If @error Then
	  Return 'else'
   EndIf

   Return $lang
EndFunc

; Installs all extracted folders into into $Bin$\$AppName$ folder, then deletes them
Func _InstallExtractedFolders()
   Local $aFolders = IniReadSection($LauncherIni,"Extract")
   For $i=1 To $aFolders[0][0]
	  _DirMove($aFolders[$i][1], '.', 1)
   Next
EndFunc

; Sunbird setup name contains the language code, then is necessary to build the remote name
Func _BuildRemoteFileName($lang)
   ;Start of the filename
   Local $sRem1_name = IniRead($LauncherIni,'Environment','X_SETUP_REMOTE_FILE','')
   ; Start string for search into page
   Local $sRem1_start = IniRead($LauncherIni,'Environment','X_SETUP_REMOTE_FILE_START','')
   ; End string for search into page
   Local $sRem1_end = IniRead($LauncherIni,'Environment','X_SETUP_REMOTE_FILE_END','')

   ; This second environment should need to be filled just for Sunbird!
   Local $sRem2 = IniRead($LauncherIni,'Environment','X_SETUP_REMOTE_FILE2','')

   ;Local $s_URL = $sSetupURL & "/" & $lang & "/"
   Local $s_URL = $baseSetupURL & "/" & $lang & "/"

   ; Find the release number from download page source
   Local $source = _INetGetSource($s_URL)
   If @error Then Return SetError(2, 0, 0)

   Local $url = _StringBetween($source, $sRem1_start, $sRem1_end)
   If @error Or $url = 0 Then Return SetError(3, 0, 0)

   ; Compose the remote download file name
   Local $sRem1 = $sRem1_name & " " & $url[0] & ".exe"

   If ($sRem2 = '') Then
	  Return $sRem1
   Else
	  Return $sRem1 & $lang & $sRem2
   EndIf
EndFunc

; Deletes the folder containing the program itself
Func _DeleteMe ()
   If FileExists (@TempDir &"\RemoveMe.cmd") then
      FileClose (@TempDir &"\RemoveMe.cmd")
      FileDelete (@TempDir &"\RemoveMe.cmd")
   EndIf
   FileWriteLine (@TEMPDIR & "\RemoveMe.cmd", "@echo off")
   FileWriteLine (@TEMPDIR & "\RemoveMe.cmd", ":loop")
   FileWriteLine (@TEMPDIR & "\RemoveMe.cmd", "del """ & @ScriptDir & "\*.*"" /S/Q")
   FileWriteLine (@TEMPDIR & "\RemoveMe.cmd", "if exist """ & @ScriptFullPath & """ goto loop")
   FileWriteLine (@TEMPDIR & "\RemoveMe.cmd", ":Loop2")
   FileWriteLine (@TEMPDIR & "\RemoveMe.cmd", "rd """ & @ScriptDir & """ /S/Q")
   FileWriteLine (@TEMPDIR & "\RemoveMe.cmd", "if exist """ & @ScriptDir & "\NUL"" goto loop2")
   FileWriteLine (@TEMPDIR & "\RemoveMe.cmd", "del " & @TEMPDIR & "\RemoveMe.cmd")
   Run (@TEMPDIR & "\RemoveMe.cmd", @TempDir, @SW_HIDE)
   Exit
EndFunc

; Returns a standard path string with only singles backslash
Func _NormalPath($path)
	Local $_normalpath, $normalpath
	$_normalpath = StringSplit(StringReplace($path, '/', '\'), '\')
	$normalpath = $_normalpath[1]
	For $n = 2 To $_normalpath[0]
		If $_normalpath[$n] <> '' Then $normalpath = $normalpath & '\' & $_normalpath[$n]
	Next
	Return $normalpath
EndFunc   ;==>_NormalPath

; Returns the full path from a relative path.
Func _FullPath($string, $sBase = $Root)
	Local $_slash, $fullpath, $up, $cd, $diff
	If $string = '' Then Return ($string)
	If StringLeft($string, 2) = '\\' Then Return ($string)
	$_slash = StringSplit(_NormalPath($string), '\')
	Select
		Case $_slash[1] = ''
			$fullpath = StringLeft($sBase, 2) & $string
		Case $_slash[1] = '.'
			$fullpath = $sBase & StringTrimLeft($string, 1)
		Case $_slash[1] = '..'
			$up = StringSplit($string, '..', 1)
			$cd = StringSplit($sBase, '\')
			$diff = $cd[0] - $up[0] + 1
			If $diff <= 0 Then Exit (10)
			$fullpath = $cd[1]
			For $i = 2 To $diff
				$fullpath = $fullpath & '\' & $cd[$i]
			Next
			$fullpath = $fullpath & $up[$up[0]]
		Case Else
			$fullpath = $string
	EndSelect
	Return ($fullpath)
EndFunc   ;==>_FullPath

; Sets the environmental variable %PATH%
Func _SetPath($string)
	Local $_paths, $path
	If $string <> '' Then
		$_paths = StringSplit($string, ';')
		$path = _FullPath($_paths[1])
		For $i = 2 To $_paths[0]
			$path = $path & ';' & _FullPath($_paths[$i])
		Next
		EnvSet('PATH', $path)
	EndIf
EndFunc   ;==>_SetPath

#EndRegion Funzioni
